#!/usr/bin/env python 
# -*- coding: utf-8 -*-

# Voronoi: http://web.archive.org/web/20161201124949/http://www.saliences.com:80/projects/npr/stippling/options.html
# Only for convenience - launches Voronoi with GIMP menu: http://gimpchat.com/viewtopic.php?f=10&t=11690
# Example code by Lylejk: start voronoi.exe -s 8000 -t .2 -n voronoi.png voronoi.svg
#                         start voronoi.exe -p 2 -n -s 3600 -t .2 -z 1 voronoi.png voronoi.svg %1  (Post Voronoi Stipple Approach to Mosaics. http://gimpchat.com/viewtopic.php?f=10&t=11690)
# The idea taken from Rob Antonishen - Shellout: http://registry.gimp.org/node/24977
# Free and open source Notepad2 Copyright © 2004-2011 Florian Balmer: http://www.flos-freeware.ch/notepad2.html

'''
License:
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 3 of the License.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
The GNU Public License is available at
http://www.gnu.org/copyleft/gpl.html
'''

from gimpfu import *
import shlex
import subprocess
import os, sys
import subprocess as sub


def plugin_main(img, layer, help_1, help_2, outputFolder, stippling):
  if help_1:
   p = sub.Popen(["D:/GIMP-2.10.5/Preferences/plug-ins/Voronoi/notepad2.exe", "D:\\GIMP-2.10.5\\Preferences\\plug-ins\\Voronoi\\vorc.bat"], stdin=sub.PIPE, stdout=sub.PIPE, stderr=sub.STDOUT) # << - Edit the path to your Voronoi directory location
   child_output, child_error = p.communicate(input="234")
   print child_output
  if help_2:
   p = sub.Popen(["D:/GIMP-2.10.5/Preferences/plug-ins/Voronoi/notepad2.exe", "D:\\GIMP-2.10.5\\Preferences\\plug-ins\\Voronoi\\vorbw.bat"], stdin=sub.PIPE, stdout=sub.PIPE, stderr=sub.STDOUT) # << - Edit the path to your Voronoi directory location
   child_output, child_error = p.communicate(input="234")
   print child_output
   #return
  gimp.pdb.file_png_save(img, layer, outputFolder + "\\" + "Voronoi" + ".png", "raw_filename", 0, 9, 0, 0, 0, 0, 0, run_mode=RUN_INTERACTIVE)
  
  if stippling == 0:
   command = "\"d:\\GIMP-2.10.5\\Preferences\\plug-ins\\Voronoi\\vorc.bat\""  # << - Edit the path to your Voronoi directory location
  else:
   command = "\"d:\\GIMP-2.10.5\\Preferences\\plug-ins\\Voronoi\\vorbw.bat\"" # << - Edit the path to your Voronoi directory location
  args = shlex.split(command)
  child = subprocess.Popen(args, shell=False)
 
register(
        "python_fu_voronoi_save-as_png",
	    "STEP 1.\n \nThis plug-ins:\n\n1. Saves (interactive) active layer as voronoi.png \n   in the directory Voronoi. \n2. Launches Voronoi.exe (console) - create fille voronoi.svg. \n------------------wait last of all working------------------\n           (then: step 2. Open voronoi svg...)",	
        "VoronoiSwith_0.6_save",
        "RobA/Lylejk/MrQ",
        "GPL",
        "2018",
        "<Image>/Filters/Artistic/ Voronoi/1. Save layer as voronoi.png...",
        "*", 
        [
        (PF_BOOL, "help_1", "Edit parameters voronoi COLOR ?                                                     ", False),
		(PF_BOOL, "help_2", "Edit parameters voronoi BLACK ?                                                     ", False),		
        (PF_DIRNAME, "outputFolder", "Output directory:", "d:\\GIMP-2.10.5\\Preferences\\plug-ins\\Voronoi"),  # << - Edit the path to your Voronoi directory location
	    (PF_OPTION, "stippling", "Dots:", 1,["Colour", "Black"]),
        ],   
        [],
        plugin_main,
        )


def open_to_layer(img, layer, file, scolor):

    gimp.progress_init("Opening '" + file + "'...")
    pdb.gimp_vectors_import_from_file(img, file, True, True)
    resolutionx, resolutiony = pdb.gimp_image_get_resolution(img)
    fileImage = pdb.file_svg_load(file, file, resolutionx, 0, 0, 2, run_mode=RUN_INTERACTIVE)
    newLayer = gimp.Layer(img, "Background", layer.width, layer.height, 0, layer.opacity, layer.mode)
    img.add_layer(newLayer, 0)               
    fileLayer = fileImage.layers[0]
    gimp.set_background(scolor)
    pdb.gimp_edit_fill (newLayer, FILL_BACKGROUND)
    pdb.gimp_edit_copy(fileLayer)
    pdb.gimp_floating_sel_to_layer(pdb.gimp_edit_paste(layer, True))
    pdb.gimp_image_lower_item_to_bottom(img,newLayer)
    return
    
register(
    "python_fu_voronoi_open_svg_to_layer_and_path",
    "STEP 2.\n \nThis plug-ins:\n\nCreates background (in the selected color) \nand interactively opens the file voronoi.svg",
    "VoronoiSwith_0.6_open",
    "RobA/Lylejk/MrQ",
    "GPL",
    "2018",
    "<Image>/Filters/Artistic/ Voronoi/2. Open voronoi.svg...",
    "*",
    [
        (PF_FILE, "file", "File to open", "D:\\GIMP-2.10.5\\Preferences\\plug-ins\\Voronoi\\voronoi.svg"), # << - Edit the path to your Voronoi directory location
		(PF_COLOR, "scolor", "_Background:", (255, 255, 255) )
    ],
    [],
    open_to_layer)
	


main()
